function x = lap_solve2(n, b)
%LAP_SOLVE2 Risolve il sistema Lx = b dove L è il laplaciano di ordine n. 
%
% Questa versione di lap_solve utilizza la fattorizzazione LU 
% sparse e le versioni sparse di sup_solve e inf_solve. 

% Questo è semplicemente un trucco per dire a MATLAB di calcolare la
% fattorizzazione LU del Laplaciano in forma sparsa, evitando di costruire
% una matrice n x n. Questo codice potrebbe essere reso più efficiente
% calcolando direttamente il laplaciano in forma sparsa. 
[L,U] = lu(sparse(laplacian(n)));

x = sup_solve3(U, inf_solve3(L, b));

end
